<template>
  <div
    class="wrapper home"
    :class="{ 'current-item--noimg': !projects[current].img }"
    :style="{
      //backgroundColor: `${bgcolor}`,
    }"
  >
    <a
      v-if="projects[current].link"
      :href="projects[current].link"
      class="project-link"
      target="_blank"
    >
      <span>{{ projects[current].link_label }}</span>
    </a>
    <div class="more-link">
      <nuxt-link v-if="current === projects.length - 1" to="me" class="link">
        <span>Contact me</span>
      </nuxt-link>
    </div>
    <div class="center--sticky leading-tight" :class="{ ready }">
      <title-anim :current="current" :projects="projects" class="anim" />
      <!-- <title-anim
        :current="current"
        :projects="projects"
        class="anim anim-bis"
      /> -->
    </div>
    <div class="content">
      <ul class="projects-list">
        <li
          v-for="(project, index) in projects"
          :key="project.slug"
          v-intersect="{
            callback: onIntersect,
            threshold: 0.5,
          }"
          :data-index="index"
          class="projects-list__item"
          :class="[
            current === index ? 'current' : '',
            project.img ? '' : 'projects-list__item--empty',
          ]"
        >
          <intersect-image
            v-if="project.img"
            :data-slug="project.slug"
            :image-url="project.img"
            :alt="project.alt"
            class="projects-list__item__image"
          />
        </li>
      </ul>
    </div>
    <!-- <div id="bg" class="fixed w-screen h-screen z-0 noise noiseBg"></div> -->
    <div class="icon-down">
      <!-- <div class="sdb04"> -->
      <!-- <span v-show="current < projects.length - 1">↓</span> -->
      <span v-show="current < projects.length - 1"></span>

      <!-- </div> -->
    </div>
  </div>
</template>

<script>
export default {
  transition(to, from) {
    if (!from) {
      return 'page'
    }

    return 'slide-left'
  },
  async asyncData({ $content, params }) {
    const projects = await $content('projects')
      // .only(['title', 'description', 'img', 'slug', 'author'])
      // .sortBy('createdAt', 'asc')
      .sortBy('sort', 'asc')
      .fetch()
    return { projects }
  },
  data() {
    return {
      current: 0,
      projects: null,
      page: null,
      bgcolor: null,
      textcolor: null,
      ready: null,
    }
  },
  mounted() {
    // const bg = document.getElementById('bg')
    // if (bg) {
    //   this.throttle('scroll', 'optimizedScroll')
    //   window.addEventListener('optimizedScroll', function () {
    //     bg.style.transform = 'rotate(' + window.pageYOffset / 100 + 'deg)'
    //   })
    // }
    ready = true
  },
  methods: {
    onIntersect(entry) {
      // project is visible
      if (entry.isIntersecting) {
        this.current = Number(entry.target.dataset.index)
        this.bgcolor = this.projects[this.current].bgcolor || 'white'
        this.textcolor = this.projects[this.current].textcolor || '#7a7a7a'
        // if (window.location.hash !== this.projects[this.current].slug)
        //   window.location.hash = this.projects[this.current].slug
      }
    },
    throttle(type, name, el) {
      const obj = el || window
      let running = false
      const func = function () {
        if (running) {
          return
        }
        running = true
        requestAnimationFrame(function () {
          obj.dispatchEvent(new CustomEvent(name))
          running = false
        })
      }
      obj.addEventListener(type, func)
    },
  },
}
</script>

<style lang="scss">
@import '~assets/scss/_mixins';
@import '~assets/scss/_vars';
@import '~assets/scss/_easings';

.wrapper.home {
  @apply min-h-screen w-screen mx-auto;
  position: fixed;
  max-width: 100vw;
  height: 100vh;
  width: 100vw;

  overflow-y: auto;
  background-color: rgb(14, 14, 14);

  .project-link,
  .more-link {
    @apply font-sans text-sm text-center block;
    color: rgb(138, 138, 138);
    position: sticky;

    top: 65%;
    @screen md {
      top: 65%;
    }

    // left: 50%;
    // transform: translate(-50%, -50%);
    @include interpolate(margin-top, $vWMin, $vWMMax, 50px, 150px);
    z-index: 100;

    mix-blend-mode: difference;
  }

  .more-link .link {
    @apply inline-block relative text-white;
  }
  .center--sticky {
    position: sticky;
    width: 100vw;
    top: 50%;
    // left: 50%;
    transform: translateY(-50%);
    background: none;
    z-index: 10;
    display: flex;
    height: auto;
    flex-direction: column;

    // opacity: 1;
    // transition: mix-blend-mode 300ms ease 400ms;
    transition: opacity 400ms $easeInOutQuad;
    opacity: 0;
    // transform: translate(-50vw, -50%);

    &.ready {
      opacity: 1;
      //   transform: translateY(-50%);
      //   transition: all 400ms $easeInOutQuad;
    }
    // black bg
    --v-text-bg-color: black;
    --v-text-color: white;
    mix-blend-mode: darken;

    // white bg
    --v-text-bg-color: rgb(0, 0, 0);
    --v-text-color: rgb(255, 255, 255);

    // mix-blend-mode: darken;
    // mix-blend-mode: exclusion;
    filter: drop-shadow(0px 0px 100px rgb(255, 255, 255));
    .anim {
      //   mix-blend-mode: darken;
    }
    // .anim-bis {
    //   transform: translateY(-50%);
    //   --v-text-bg-color: white;
    //   --v-text-color: white;
    //   mix-blend-mode: lighten;
    //   filter: blur(30px);
    // }
  }

  .icon-down {
    opacity: 0;
  }
  &.current-item--noimg {
    background-color: rgb(249, 245, 245);

    .project-link {
      color: white;
    }
    .header {
      --v-text-color: white;
      mix-blend-mode: initial;
      --v-text-bg-color: black;
    }

    .icon-down {
      opacity: 1;
      transition: opacity 300ms ease 1400ms;
    }
  }
}

.projects-list {
  @apply flex flex-col justify-center items-center;

  @screen lg {
    max-width: 40vw;
  }
  @apply mx-auto;
  &__item {
    @apply block w-screen flex flex-col justify-center items-center;
    @apply bg-opacity-0 transition-colors duration-200;
    @screen lg {
      @apply my-20;
    }
    min-height: 90vh;
    $color-1: rgb(139, 138, 138);
  }
  &__item.current {
    @apply bg-opacity-100;
  }
  &__item--empty {
    min-height: 99vh;
  }
}

body {
  background-attachment: fixed;
  background-position-x: 0px;
  background-position-y: 0px;
  z-index: -1;

  // background-image: url("data:image/svg+xml,%3Csvg width='8' height='10' viewBox='0 0 16 20' xmlns='http://www.w3.org/2000/svg'%3E%3Cg fill='%23000000' fill-opacity='0.4' fill-rule='evenodd'%3E%3Cpath d='M8 0v20L0 10M16 0v10L8 0M16 10v10H8'/%3E%3C/g%3E%3C/svg%3E");
  // background-size: cover;
}

.noise {
  // background-position: px;
  // background-color: #eaeaea;
  // width: 300vw;
  // height: 300vh;
  // left: 50%;
  // top: 50%;
  // transform: translate(-50%, -50%);
  opacity: 0.6;
  top: -100vh;
  // bottom: -100vw;
  left: -100vw;
  // right: -200vw;
  height: 300vh;
  width: 300vw;
  // background-attachment: fixed;
  background-position-x: 0px;
  background-position-y: 0px;
  transform-origin: center;
  // background-image: url("data:image/svg+xml,%3Csvg width='8' height='10' viewBox='0 0 16 20' xmlns='http://www.w3.org/2000/svg'%3E%3Cg fill='%23000000' fill-opacity='0.4' fill-rule='evenodd'%3E%3Cpath d='M8 0v20L0 10M16 0v10L8 0M16 10v10H8'/%3E%3C/g%3E%3C/svg%3E");

  // background-size: cover;
  z-index: -1;
  // transition: transform 700ms $easeInOutQuad;
  // -webkit-animation: AnimationName 500ms ease;
  // -moz-animation: AnimationName 500ms ease;
  // animation: spin 12500ms linear infinite;
}

.noiseBg {
  background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='4' height='4' viewBox='0 0 10 10'%3E%3Cg fill='%23a19f9f' fill-opacity='1'%3E%3Cpath fill-rule='evenodd' d='M0 0h4v4H0V0zm4 4h4v4H4V4z'/%3E%3C/g%3E%3C/svg%3E");
}

@keyframes spin {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
.icon-down {
  @apply sticky bottom-0  text-black text-center text-3xl;
  bottom: 55px;
  @screen lg {
    bottom: 30px;
  }
  //   margin-top: 150px;
  //   left: 50%;
  //   transform: translateX(-50%);
  opacity: 1;
  //   transition: opacity 400ms;
  padding-top: 60px;

  transition: none;
}

.icon-down span {
  position: absolute;
  top: 0;
  left: 50%;
  width: 24px;
  height: 24px;
  margin-left: -12px;
  border-left: 2px solid #000;
  border-bottom: 2px solid #000;
  -webkit-transform: rotate(-45deg);
  transform: rotate(-45deg);
  -webkit-animation: sdb04 4s infinite;
  animation: sdb04 4s infinite;
  box-sizing: border-box;
}

@keyframes sdb04 {
  0% {
    transform: rotate(-45deg) translate(0, 0);
  }
  20% {
    transform: rotate(-45deg) translate(-10px, 10px);
  }
  40% {
    transform: rotate(-45deg) translate(0, 0);
  }
}
</style>
